clear;
datasets = {'may_03_2011'}; %{'jan_25_2011', 'apr_09_2010','feb_26_2010', 'SignStreamDatabases_no_compounds','jan_27_2010','apr_30_2010'};

addpath '/research/surveillance2/ashwin/asl/code/hand_detector';
signers_and_sessions_list;
gloss_translation_file = '../jessica_glossing_conventions/GlossingConventions3-2-11.csv';

if 1;
	
clear('gloss_infos', 'gloss_info');
all_gloss_dir = '/research/asl-data2/quicktime/annotate/all_sign_glosses/';
[corpus_gloss_id, corpus_gloss] = textread([all_gloss_dir, 'all_signs.csv'], '%s%s', 'delimiter', ',');
corpus_gloss = lower(corpus_gloss);
corpus_gloss_processed = {};
corpus_gloss_is_loan_sign = [];
for corpusi = 1:length(corpus_gloss);
	cur_gloss = corpus_gloss{corpusi};
	cur_gloss(strfind(cur_gloss,'-')) = [];	cur_gloss(strfind(cur_gloss,'_')) = [];
	corpus_gloss_processed{corpusi} = cur_gloss;
	corpus_gloss_is_loan_sign(corpusi) = 0;
end
loan_signs_gloss_list = lower(textread('loan_signs.csv','%s', 'whitespace', '\n'));
for corpusi = 1:length(loan_signs_gloss_list);
	cur_gloss = loan_signs_gloss_list{corpusi};
	cur_gloss(strfind(cur_gloss,'-')) = [];	cur_gloss(strfind(cur_gloss,'_')) = [];
	loan_signs_gloss_list{corpusi} = cur_gloss;
end
gloss_suffixes = {'','fr','1fr','1'};
loan_signs_with_suffix = {};
loanj = 1;
for suffixi = 1:length(gloss_suffixes);
	for loani = 1:length(loan_signs_gloss_list);
		loan_signs_with_suffix{loanj} = [loan_signs_gloss_list{loani},gloss_suffixes{suffixi}];
		loanj = loanj + 1;
	end
end
for corpusi = 1:length(corpus_gloss_processed);
	if ~isempty(strmatch(corpus_gloss_processed{corpusi}, loan_signs_with_suffix, 'exact'));
		corpus_gloss_is_loan_sign(corpusi) = 1;
		fprintf('loan_sign: %s\n', corpus_gloss_processed{corpusi});
	end
end
num_orig_gallaudet_corpus_gloss		= length(corpus_gloss);
extended_lexicon_corpus_gloss_start	= 4000;
extended_lexicon_corpus_gloss_id	= extended_lexicon_corpus_gloss_start;

dataset_text = {};
for dataseti = 1:length(datasets);
	input_file = ['../processed_annotations/',datasets{dataseti},'.out'];
	input_text = textread(input_file,'%s', 'whitespace', '\n');
	dataset_text = {dataset_text{:},input_text{:}};
end

compound_glosses = [];
signer_gloss_infos = [];
annotation_sections = strmatch('9999999', dataset_text, 'exact');
annotation_sections(end+1) = length(dataset_text) + 1;
for sectioni = 1:length(annotation_sections)-1;
	section_annotation = {dataset_text{annotation_sections(sectioni)+1:annotation_sections(sectioni+1)-1}};
	gloss_section1 = strmatch('7777777', section_annotation, 'exact');
	gloss_section2 = strmatch('5555555', section_annotation, 'exact');
	current_gloss = '';
	if length(gloss_section1) > 0 && gloss_section1 < length(section_annotation) && length(section_annotation{gloss_section1+1}) > 0;
		current_gloss = section_annotation{gloss_section1+1};
	elseif length(gloss_section2) > 0 && gloss_section2 < length(section_annotation) && length(section_annotation{gloss_section2+1}) > 0;
		current_gloss = section_annotation{gloss_section2+1};
	else
		continue;
	end
	section_annotation = {section_annotation{1:min([gloss_section1, gloss_section2])-1}};
	clear('gloss_info');
	gloss_info.utterance_xml = section_annotation{1};
	gloss_info.xml_modified_time = uint32(sscanf(section_annotation{2},'%d'));
	[session, utterance_video] = strtok(section_annotation{3}, '\'); utterance_video = utterance_video(2:end);
	if ~strcmp(session(1:3),'ASL');
		t = strfind(gloss_info.utterance_xml,'/'); if length(t) == 0; continue; end
		tstr = gloss_info.utterance_xml(t(end-1)+1:t(end)-1);
		t = strfind(tstr,'-'); if length(t) == 0; continue; end
		session = ['ASL_',tstr(1:t(1)-1)];
	end
	utterance_xml_filename 	= gloss_info.utterance_xml;
	if ~isempty( strfind( utterance_xml_filename,'/' ) );
		utterance_xml_filename	= utterance_xml_filename( find(utterance_xml_filename == '/',1,'last')+1:end );
	end
	if isempty( find(utterance_xml_filename == '.') ); continue; end
	utterance_xml_filename		= utterance_xml_filename(1:find(utterance_xml_filename == '.',1,'first')-1);
	is_utt_macro_unit_match		= min( [ strfind( utterance_xml_filename, 'Utt' ), strfind( utterance_xml_filename, 'macro_unit_' ), ...
											strfind( utterance_xml_filename, 'utter' ) ] );
	if isempty( is_utt_macro_unit_match )	||	is_utt_macro_unit_match ~= 1;
		current_gloss			= utterance_xml_filename;
	end
	current_gloss = lower(current_gloss); 	current_gloss(strfind(current_gloss,' ')) = '_';
	scene = sscanf(utterance_video,'scene%d-camera%d.mov');
	if length(scene) == 0; continue; end
	gloss_info.session = session;
	gloss_info.scene = scene(1);
	gloss_info.gloss = current_gloss;
	gloss_info.gloss_period = [];
	gloss_info.onset_period = [];
	gloss_info.offset_period = [];
	gloss_info.lhand_info = [];
	gloss_info.rhand_info = [];
	gloss_info.is_loan_sign = 0;

	cur_gloss_is_new_liz_set	= strcmp( session, 'ASL_2010_08_10_Liz_additional_lexicon_signs' );

	cur_corpus_gloss_id 		= strmatch(gloss_info.gloss, corpus_gloss, 'exact');
	if isempty(cur_corpus_gloss_id) 			|| 	cur_gloss_is_new_liz_set;
		cur_gloss = gloss_info.gloss;
		cur_gloss(strfind(cur_gloss,'-')) 	= [];	cur_gloss(strfind(cur_gloss,'_')) = [];
		cur_corpus_gloss_id = strmatch(cur_gloss, corpus_gloss_processed, 'exact');
		if isempty(cur_corpus_gloss_id)			||	cur_gloss_is_new_liz_set;
			cur_corpus_gloss_id = strmatch(cur_gloss, corpus_gloss_processed);
			if isempty(cur_corpus_gloss_id)		||	cur_gloss_is_new_liz_set;
				% fprintf('No matching gloss in corpus for %s, adding a new entry in the lexicon.\n', gloss_info.gloss);
				for corpus_glossi		= length( corpus_gloss ) + 1 : extended_lexicon_corpus_gloss_id;
					corpus_gloss{ corpus_glossi }				= '';
				end
				if	cur_gloss_is_new_liz_set;
					gloss_info.gloss	= sprintf( 'EX:%s', 	gloss_info.gloss );
				end
				cur_corpus_gloss_id								= extended_lexicon_corpus_gloss_id;
				corpus_gloss{cur_corpus_gloss_id}				= gloss_info.gloss;
				corpus_gloss_is_loan_sign(cur_corpus_gloss_id)	= 0;
				extended_lexicon_corpus_gloss_id				= extended_lexicon_corpus_gloss_id + 1;
				%continue;
			end
		end
	end
	cur_corpus_gloss_id		= cur_corpus_gloss_id(1);
	gloss_info.gloss		= corpus_gloss{cur_corpus_gloss_id};
	gloss_info.is_loan_sign = corpus_gloss_is_loan_sign(cur_corpus_gloss_id);
	
	signeri = [];
	for signerj = 1:length(signer_sessions);
		if ~isempty(strmatch(gloss_info.session, signer_sessions{signerj}));
			signeri = signerj;
			break;
		end
	end
	if isempty(signeri);
		fprintf('No matching signer session found for %s.\n', gloss_info.session); continue;
	end
	
	subsection_ids = {'1000', '2000', '10000'};
	subsections = [];
	for i = 1:length(subsection_ids);
		t = strmatch(subsection_ids{i}, section_annotation, 'exact');
		for tii = 1:length(t);
			tj	= t(tii);
			if tj < length(section_annotation) && strcmp( section_annotation{tj + 1}, '8888888' );
				subsections(end+1) = tj;
			end
		end
	end
	if isempty(subsections); continue; end
	subsections(end+1) = length(section_annotation) + 1;
	subsections = sort(subsections, 'ascend');
	clear subsection_parsed_entities;
	time_scaling = 2000;
	for subsectioni = 1:length(subsections)-1;
		subsection_id = sscanf(section_annotation{subsections(subsectioni)}, '%d');
		subsection_annotation = {section_annotation{subsections(subsectioni)+1:subsections(subsectioni+1)-1}};
		
		entities = strmatch('8888888', subsection_annotation, 'exact');
		if isempty(entities); continue; end
		entities(end+1) = length(subsection_annotation)+1;
		clear parsed_entities;
		entities_start_times = [];
		entityj = 1;
		for entityi = 1:length(entities) - 1;
			entity_subsection_annotation = {subsection_annotation{entities(entityi)+1:entities(entityi+1)-1}};
			items = strmatch('6666666', entity_subsection_annotation, 'exact');
			items(end+1) = length(entity_subsection_annotation)+1;
			entity_items = {};
			itemk = 0;
			for itemi = 1:length(items) - 1;
				item_subsection = {entity_subsection_annotation{items(itemi)+1:items(itemi+1)-1}};
				if (subsection_id == 10000 && length(item_subsection) ~= 4) || ...
				   ((subsection_id == 1000 || subsection_id == 2000) && length(item_subsection) ~= 3);
					continue;
				end
				itemk = itemk + 1;
				for itemj = 1:length(item_subsection);
					entity_items{itemj,itemk} = item_subsection{itemj};
				end
			end
			if isempty(entity_items); continue; end
			[item_start_time, sort_order] = sort(str2double({entity_items{2,:}}));
			entity_item_nrows = size(entity_items,1);
			parsed_entities(entityj).entity_items = reshape({entity_items{:,sort_order}}, entity_item_nrows, []);
			parsed_entities(entityj).entity_start_time = item_start_time(1);
			parsed_entities(entityj).entity_end_time = str2double(parsed_entities(entityj).entity_items{1,end});
			entities_start_times(entityj) = item_start_time(1);
			parsed_entities(entityj).num_items = size(entity_items,2);
			entityj = entityj + 1;
		end
		[entities_start_times, sort_order] = sort(entities_start_times);
		parsed_entities = parsed_entities(sort_order);
		keep_entity = [];
		unique_entity_start_times = unique(entities_start_times);
		for unique_entityi = 1:length(unique_entity_start_times);
			match_entities = find(entities_start_times == unique_entity_start_times(unique_entityi));
			[t, max_match_entity] = max([parsed_entities(match_entities).num_items]);
			keep_entity(end+1) = match_entities(max_match_entity);
		end
		parsed_entities = parsed_entities(keep_entity);
		
		switch( subsection_id );
			case 10000
				subsectionj = 1;
				onset_subentityi = [];
				for onset_entityi = 1:length(parsed_entities);
					onset_subentityi = strmatch('Onset',{parsed_entities(onset_entityi).entity_items{end,:}},'exact');
					if length(onset_subentityi) > 0; break; end
				end
				offset_subentityi = [];
				for offset_entityi = 1:length(parsed_entities);
					offset_subentityi = strmatch('Offset',{parsed_entities(offset_entityi).entity_items{end,:}},'exact');
					if length(offset_subentityi) > 0; break; end
				end
				if length(onset_subentityi) == 0 || length(offset_subentityi) == 0;
					%fprintf(2,'Cannot find an entry for either Offset or Onset.\n');
					%fprintf(2,'%s %s\n', gloss_info.gloss, gloss_info.utterance_xml);
					continue;
				end
				subsection_num = str2double({parsed_entities(onset_entityi).entity_items{:,onset_subentityi}});
				gloss_info.onset_period = subsection_num(2:-1:1) / time_scaling;
				subsection_num = str2double({parsed_entities(offset_entityi).entity_items{:,offset_subentityi}});
				gloss_info.offset_period = subsection_num(2:-1:1) / time_scaling;
				
				parsed_entities(onset_entityi).entity_items = reshape({parsed_entities(onset_entityi).entity_items{:,onset_subentityi+1:end}},4,[]);
				parsed_entities(onset_entityi).entity_start_time = sscanf(parsed_entities(onset_entityi).entity_items{2,1},'%d');
				
				parsed_entities(offset_entityi).entity_items = reshape({parsed_entities(offset_entityi).entity_items{:,1:offset_subentityi-1}},4,[]);
				parsed_entities(offset_entityi).entity_end_time = sscanf(parsed_entities(offset_entityi).entity_items{1,end},'%d');
				parsed_entities = parsed_entities(onset_entityi:offset_entityi);
			case 1000
				subsectionj = 2;
			case 2000
				subsectionj = 3;
			otherwise
				error('invalid subsection_id');
		end
		subsection_parsed_entities(subsectionj).parsed_entities = parsed_entities;
	end
	if ~exist('subsection_parsed_entities','var') || length(subsection_parsed_entities(1).parsed_entities) == 0;
		continue;
	end
	
	for base_entityi = 1:length(subsection_parsed_entities(1).parsed_entities);
		subsection_num = str2double({subsection_parsed_entities(1).parsed_entities(base_entityi).entity_items{:,1}});
		
		entity_gloss_info.gloss_period = subsection_num(2:-1:1) / time_scaling;
		entity_gloss_info.subgloss = subsection_parsed_entities(1).parsed_entities(base_entityi).entity_items{end,1};
		gloss_entity_start_time = subsection_parsed_entities(1).parsed_entities(base_entityi).entity_start_time;
		gloss_entity_end_time = subsection_parsed_entities(1).parsed_entities(base_entityi).entity_end_time;
		entity_gloss_info.rhand_info = [];
		entity_gloss_info.lhand_info = [];
		
		for subsectionj = 2:length(subsection_parsed_entities);
			if isempty(subsection_parsed_entities(subsectionj).parsed_entities);
				continue;
			end
			hand_entitiy_start_time = [subsection_parsed_entities(subsectionj).parsed_entities(:).entity_start_time];
			hand_entitiy_end_time = [subsection_parsed_entities(subsectionj).parsed_entities(:).entity_end_time];
			hand_entitiy_gloss_entity_overlap = [];
			for hand_entitiyi = 1:length(subsection_parsed_entities(subsectionj).parsed_entities);
				hand_entitiy_gloss_entity_overlap(hand_entitiyi) = min(hand_entitiy_end_time(hand_entitiyi), gloss_entity_end_time) - ...
																   max(hand_entitiy_start_time(hand_entitiyi), gloss_entity_start_time);
			end
			[best_overlap, hand_entityi] = max(hand_entitiy_gloss_entity_overlap);
			%if length(subsection_parsed_entities(1).parsed_entities) > 1; fprintf(''); end
			if best_overlap < 0; continue; end
			
			handshape_entity_num = str2double(subsection_parsed_entities(subsectionj).parsed_entities(hand_entityi).entity_items);
			handshape_entity_num(1:2,:) = handshape_entity_num(1:2,:)/time_scaling;
			if subsectionj == 2;
				entity_gloss_info.rhand_info = handshape_entity_num;
			else
				entity_gloss_info.lhand_info = handshape_entity_num;
			end
		end
		if length(subsection_parsed_entities(1).parsed_entities) == 1;
			gloss_info.gloss_period = entity_gloss_info.gloss_period;
			gloss_info.lhand_info = entity_gloss_info.lhand_info;
			gloss_info.rhand_info = entity_gloss_info.rhand_info;
			gloss_info.compound_gloss = [];
			if ~isempty(gloss_info.rhand_info);
				gloss_info.gloss_period = [gloss_info.rhand_info(1,1), gloss_info.rhand_info(2,end)];
			end
		else
			gloss_info.compound_gloss(base_entityi).gloss_period = entity_gloss_info.gloss_period;
			gloss_info.compound_gloss(base_entityi).lhand_info = entity_gloss_info.lhand_info;
			gloss_info.compound_gloss(base_entityi).rhand_info = entity_gloss_info.rhand_info;
			subgloss = entity_gloss_info.subgloss;
			if isempty(strfind(subgloss, 'CL-'))&&isempty(strfind(subgloss, 'CL:')); subgloss = lower(subgloss); end
			gloss_info.compound_gloss(base_entityi).subgloss = subgloss;
			if ~isempty(gloss_info.compound_gloss(base_entityi).rhand_info);
				gloss_info.compound_gloss(base_entityi).gloss_period = ...
					[gloss_info.compound_gloss(base_entityi).rhand_info(1,1), gloss_info.compound_gloss(base_entityi).rhand_info(2,end)];
			end
		end
	end
	
	if length(gloss_info.compound_gloss) > 0;
		subgloss_period = reshape([gloss_info.compound_gloss(:).gloss_period], 2, []);
		gloss_info.gloss_period = [min(subgloss_period(1,:)), max(subgloss_period(2,:))];
		compound_glosses(end+1).gloss = gloss_info.gloss;
		compound_glosses(end).subgloss = {gloss_info.compound_gloss.subgloss};
		%fprintf('%15s %20s ',gloss_info.session, gloss_info.gloss); fprintf('%20s ',gloss_info.compound_gloss.subgloss); fprintf('\n');
	end
	
	cur_corpus_gloss_id_saved_gloss = [];
	replace_gloss_info = 0;
	if signeri > length(signer_gloss_infos) || ...
	   cur_corpus_gloss_id > length(signer_gloss_infos(signeri).gloss_infos) || ...
	   isempty(signer_gloss_infos(signeri).gloss_infos(cur_corpus_gloss_id).gloss);
			replace_gloss_info = 1;
	else
		cur_corpus_gloss_id_saved_gloss = signer_gloss_infos(signeri).gloss_infos(cur_corpus_gloss_id);
	end
	if replace_gloss_info == 0;
		if isempty(cur_corpus_gloss_id_saved_gloss.compound_gloss) && ~isempty(gloss_info.compound_gloss);
			replace_gloss_info = 1;
		elseif ~isempty(cur_corpus_gloss_id_saved_gloss.compound_gloss) && isempty(gloss_info.compound_gloss);
			replace_gloss_info = 0;
		elseif cur_corpus_gloss_id_saved_gloss.xml_modified_time < gloss_info.xml_modified_time;
			replace_gloss_info = 1;
		elseif strcmp(cur_corpus_gloss_id_saved_gloss.gloss, corpus_gloss{cur_corpus_gloss_id}) ~= 1 && ...
				strcmp(gloss_info.gloss, corpus_gloss{cur_corpus_gloss_id}) == 1;
			replace_gloss_info = 1;
		elseif cur_corpus_gloss_id_saved_gloss.scene < gloss_info.scene || ...
			   cur_corpus_gloss_id_saved_gloss.gloss_period(1) < gloss_info.gloss_period(1);
			replace_gloss_info = 1;
		else
			%fprintf('Duplicate annotation.\n');
			%gloss_info
			%cur_corpus_gloss_id_saved_gloss
		end
	end
	if replace_gloss_info; signer_gloss_infos(signeri).gloss_infos(cur_corpus_gloss_id) = gloss_info; end
end

addpath('/research/surveillance2/ashwin/asl/code/hand_detector', ...
		'/research/surveillance2/ashwin/asl/software/video_compressor/vid_reader');
vid_handle = [];
netavi_handle = [];
prev_videofile = '';

for singeri = 1:length(signer_gloss_infos);
	gloss_infos = signer_gloss_infos(singeri).gloss_infos;
	cur_scene_start_glossi = 1;
	cur_scene 	= gloss_infos(1).scene;
	cur_session = gloss_infos(1).session;
	for glossi 	= 1:length(gloss_infos) + 1;
		if 	glossi <= length(gloss_infos) 	&& isempty(gloss_infos(glossi).gloss); 	continue; 	end
		if 	glossi > length(gloss_infos) 	|| gloss_infos(glossi).scene ~= cur_scene;
			scene_video_file 		= sprintf('%s/scene%d-camera1.vid', cur_session, cur_scene);
			cur_info.video_file 	= get_full_ASL_vid_directory(scene_video_file);
			openVideoFile;
			cur_scene_end_glossi 	= glossi - 1;
			cur_scene_glossi 		= [cur_scene_start_glossi:cur_scene_end_glossi];
			tt 		= gloss_infos(cur_scene_glossi);
			for ttj = length(tt):-1:1;
				if 	~isempty(tt(ttj).gloss); break; end
			end
			if tt(ttj).gloss_period(2) > vid_info.NumFrames 	|| ...
				( strcmp( cur_session, 'ASL_2008_08_13' ) && sum( cur_scene == [9, 12] ) );
				for tti = 1:length(tt);
					if isempty(tt(tti).gloss); continue; end
					tt(tti).gloss_period = floor(tt(tti).gloss_period/2);
					tt(tti).onset_period = floor(tt(tti).onset_period/2);
					tt(tti).offset_period = floor(tt(tti).offset_period/2);
					if ~isempty(tt(tti).rhand_info); tt(tti).rhand_info(1:2,:) = floor(tt(tti).rhand_info(1:2,:)/2); end
					if ~isempty(tt(tti).lhand_info); tt(tti).lhand_info(1:2,:) = floor(tt(tti).lhand_info(1:2,:)/2); end
					if ~isempty(tt(tti).compound_gloss);
						ttt = tt(tti).compound_gloss;
						for ttti = 1:length(ttt);
							ttt(ttti).gloss_period = floor(ttt(ttti).gloss_period/2);
							if ~isempty(ttt(ttti).rhand_info); ttt(ttti).rhand_info(1:2,:) = floor(ttt(ttti).rhand_info(1:2,:)/2); end
							if ~isempty(ttt(ttti).lhand_info); ttt(ttti).lhand_info(1:2,:) = floor(ttt(ttti).lhand_info(1:2,:)/2); end
						end
						tt(tti).compound_gloss = ttt;
					end
				end
				gloss_infos(cur_scene_glossi) = tt;
			end
			if glossi <= length(gloss_infos);
				cur_scene = gloss_infos(glossi).scene;
				cur_session = gloss_infos(glossi).session;
			end
			cur_scene_start_glossi = glossi;
		end
		signer_gloss_infos(singeri).gloss_infos = gloss_infos;
	end
end

end

[ gloss_labels_from_movie, gallaudet_glosses ] = ...
		textread(gloss_translation_file, '%s %s', 'delimiter', ';', 'whitespace', '', 'endofline', '\r\n');
gloss_labels_from_movie = strrep( lower( gloss_labels_from_movie ), '-', '_' );

for singeri = 1:length(signer_gloss_infos);
	fp = fopen(sprintf('../processed_annotations/%s_handshapes.csv', signers{singeri}), 'w');
	gloss_infos = signer_gloss_infos(singeri).gloss_infos;
	fprintf(fp,'#,Sign label,Gallaudet gloss,Compound signs,Session,Scene,XML,MOV,Sign start,Sign end,');
	fprintf(fp,'Dominant handshape IDs,Non-dominant handshape IDs,Dominant handshape frames,Non-dominant handshape frames\n');
	for glossi = 1:length(gloss_infos);
		gloss_info = gloss_infos(glossi);
		if isempty(gloss_info.gloss); continue; end
		
		gallaudet_gloss_description = '';
		cur_gloss = strrep(lower(gloss_info.gloss), '-', '_');
		gallaudet_gloss_index = strmatch( cur_gloss, gloss_labels_from_movie, 'exact' );
		if isempty(gallaudet_gloss_index);
			gallaudet_gloss_index = strmatch( cur_gloss, gloss_labels_from_movie );
		end
		if isempty(gallaudet_gloss_index);
			gallaudet_gloss_index = strmatch( cur_gloss(1:end-1), gloss_labels_from_movie );
		end
		if ~isempty(gallaudet_gloss_index);
			gallaudet_gloss_index		= gallaudet_gloss_index(1);
			gallaudet_gloss_description = gallaudet_glosses{gallaudet_gloss_index};
			signer_gloss_infos(singeri).gloss_infos(glossi).gallaudet_gloss_description = gallaudet_gloss_description;
			gallaudet_gloss_description = strrep(gallaudet_gloss_description, ',', '~');
		else
			fprintf('Cannot find Gallaudet gloss descriptor for sign label: %s.\n', cur_gloss);
			gallaudet_gloss_description = upper( cur_gloss );
			if 	length( gallaudet_gloss_description ) > 3 	&& 	strcmp( gallaudet_gloss_description( 1:3 ), 'EX:' );
				gallaudet_gloss_description = gallaudet_gloss_description( 4:end );
			end
			signer_gloss_infos(singeri).gloss_infos(glossi).gallaudet_gloss_description = gallaudet_gloss_description;
		end
		
		compound_gloss_str = '';
		hand_strs = {};
		hand_strs2 = {};
		for k = 1:2;
			hand_strs{k} = ''; hand_strs2{k} = '';
		end
		if isempty(gloss_info.compound_gloss);
			for k = 1:2;
				if k == 1;
					hand_info = gloss_info.rhand_info;
				else
					hand_info = gloss_info.lhand_info;
				end
				if isempty(hand_info); continue; end
				for l = 1:size(hand_info,2);
					white_spacing = '^'; if l == size(hand_info,2); white_spacing = ''; end
					hand_strs{k} = sprintf('%s%d%s', hand_strs{k}, hand_info(3,l), white_spacing);
					hand_strs2{k} = sprintf('%s%d%s', hand_strs2{k}, hand_info(1,l), white_spacing);
				end
			end
		else
			for compoundi = 1:length(gloss_info.compound_gloss);
				linebreak = ''; if compoundi ~= 1; linebreak = '~'; end
				compound_gloss = gloss_info.compound_gloss(compoundi);
				compound_gloss_str = sprintf('%s%s%s',compound_gloss_str,linebreak,compound_gloss.subgloss);
				for k = 1:2;
					if k == 1;
						hand_info = compound_gloss.rhand_info;
					else
						hand_info = compound_gloss.lhand_info;
					end
					if isempty(hand_info); continue; end
					hand_strs{k} = sprintf('%s%s',hand_strs{k}, linebreak);
					hand_strs2{k} = sprintf('%s%s',hand_strs2{k}, linebreak);
					for l = 1:size(hand_info,2);
						white_spacing = '^'; if l == size(hand_info,2); white_spacing = ''; end
						hand_strs{k} = sprintf('%s%d%s', hand_strs{k}, hand_info(3,l), white_spacing);
						hand_strs2{k} = sprintf('%s%d%s', hand_strs2{k}, hand_info(1,l), white_spacing);
					end
				end
			end
		end
		session = gloss_info.session(5:end);
		utterance_xml = gloss_info.utterance_xml;
		utterance_xml = strrep(utterance_xml, ' ', '^');
		movie = sprintf('mov/%s/scene%d-camera1.mov', gloss_info.session, gloss_info.scene);
		fprintf(fp,'%d,%s,%s,%s,%s,%d,%s,%s,', glossi, gloss_info.gloss, gallaudet_gloss_description, compound_gloss_str, ...
					session, gloss_info.scene, utterance_xml, movie);
		fprintf(fp, '%d,%d,%s,%s,%s,%s\n', ...
					gloss_info.gloss_period(1), gloss_info.gloss_period(2), ...
					hand_strs{1}, hand_strs{2}, hand_strs2{1}, hand_strs2{2});
	end
	fclose(fp);
end

for singeri = 1:length(signer_gloss_infos);
	fp2 = fopen(sprintf('../processed_annotations/%s_all_annotate.csv', signers{singeri}), 'w');
	fprintf(fp2, 'Dictionary index,Session and Scene,Sign gloss labels from the Gallaudet Dictionary,Start frame,End frame\n');
	gloss_infos = signer_gloss_infos(singeri).gloss_infos;
	cur_session = '';
	cur_scene = 0;
	fp1 = [];	
	cur_session_id = 0;
	for glossi = 1:length(gloss_infos);
		gloss_info = gloss_infos(glossi);
		if isempty(gloss_info.gloss);
			gloss_info.gloss = '';
			gloss_info.session = '';
			gloss_info.utterance_xml = '';
			gloss_info.scene = 0;
			signer_gloss_infos(singeri).gloss_infos(glossi) = gloss_info;
			continue;
		end
		if ~strcmp(gloss_info.session, cur_session);
			if ~isempty(fp1); fclose(fp1); end
			cur_session = gloss_info.session;
			fp1 = fopen(sprintf('../processed_annotations/%s.csv', cur_session), 'w');
			fprintf(fp2, '\n,%s,,,\n\n',cur_session);
			cur_session_id = cur_session_id + 1;
		end
		scene_str = '';
		if cur_scene ~= gloss_info.scene;
			cur_scene = gloss_info.scene;
			scene_str = sprintf('scene%d-camera1.mov', cur_scene);
		end
		fprintf(fp1, '1,%d,%d,%d,%s\n', gloss_info.scene, gloss_info.gloss_period(1), gloss_info.gloss_period(2), gloss_info.gloss);
		fprintf(fp2, '%d,%s,%s,%d,%d\n', glossi, scene_str, gloss_info.gloss, gloss_info.gloss_period(1), gloss_info.gloss_period(2));
	end
	fclose(fp1);
	fclose(fp2);
end

compound_glosses_gloss = {compound_glosses(:).gloss};
[compound_glosses_gloss, sort_order] = sort(compound_glosses_gloss);
compound_glosses = compound_glosses(sort_order);
[compound_glosses_gloss, uniq_index] = unique(compound_glosses_gloss);
compound_glosses = compound_glosses(uniq_index);
corpus_gloss_compounds_unrolled = {};
corpus_gloss_num_compound_parts = [];
compounds_unrolledi = 1;
for corpusi = 1:length(corpus_gloss);
	if isempty(strmatch(corpus_gloss{corpusi}, compound_glosses_gloss, 'exact'));
		corpus_gloss_compounds_unrolled{compounds_unrolledi} = corpus_gloss{corpusi};
		corpus_gloss_num_compound_parts(corpusi) = 0;
		compounds_unrolledi = compounds_unrolledi + 1;
	else
		signer_compounds_length = [];
		for signeri = 1:length(signer_gloss_infos);
			if length(signer_gloss_infos(signeri).gloss_infos) >= corpusi;
				signer_compounds_length(signeri) = length(signer_gloss_infos(signeri).gloss_infos(corpusi).compound_gloss);
			end
		end
		if max(signer_compounds_length) == 0; continue; end
		[t,maxi] = max(signer_compounds_length);
		signer_compound = signer_gloss_infos(maxi).gloss_infos(corpusi).compound_gloss;
		for compoundi = 1:length(signer_compound);
			corpus_gloss_compounds_unrolled{compounds_unrolledi} = sprintf('%s-@%d',corpus_gloss{corpusi}, compoundi);
			compounds_unrolledi = compounds_unrolledi + 1;
		end
		corpus_gloss_num_compound_parts(corpusi) = length(signer_compound);
	end
end

agentic_compounds = []; non_agentic_compounds = [];
for compoundi = 1:length(compound_glosses);
	if ~isempty(strmatch('agent', compound_glosses(compoundi).subgloss, 'exact'));
		agentic_compounds(end+1) = compoundi;
	else
		non_agentic_compounds(end+1) = compoundi;
	end
end
for compoundj = 1:2;
	if compoundj == 1;
		compounds = agentic_compounds;
	else
		compounds = non_agentic_compounds;
	end
	for compoundi = 1:length(compounds);
		fprintf('%s := ', compound_glosses(compounds(compoundi)).gloss);
		subgloss = compound_glosses(compounds(compoundi)).subgloss;
		fprintf('%s+%s\n',subgloss{1},subgloss{2});
	end
	fprintf('\n');
end

orig_signer_gloss_infos				= [];
extra_signer_gloss_infos			= [];
num_extra_signer_gloss_infos		= [];
for signeri 	= 1:length(signer_gloss_infos);
	orig_signer_gloss_infos( signeri ).gloss_infos 		= signer_gloss_infos( signeri ).gloss_infos( ...
												1 : min( num_orig_gallaudet_corpus_gloss, length(signer_gloss_infos(signeri).gloss_infos) ) );
	extra_signer_gloss_infos( signeri ).gloss_infos 	= signer_gloss_infos( signeri ).gloss_infos( extended_lexicon_corpus_gloss_start : end );
	num_extra_signer_gloss_infos( signeri )	= length( extra_signer_gloss_infos( signeri ).gloss_infos );
end
signer_gloss_infos	= orig_signer_gloss_infos;

for signeri			= 1:length(signer_gloss_infos);
	for glossi		= num_extra_signer_gloss_infos( signeri ) + 1 : max( num_extra_signer_gloss_infos );
		extra_signer_gloss_infos( signeri ).gloss_infos( glossi ).gloss	= '';
	end
end

if 0;
	save( 	'../processed_annotations/all_sessions.mat', 'signer_gloss_infos', 'extra_signer_gloss_infos', ...
			'corpus_gloss',	'compound_glosses', ...
			'corpus_gloss_num_compound_parts', 'corpus_gloss_compounds_unrolled', 'agentic_compounds', 'non_agentic_compounds' );
end
