#!/bin/bash

if [ "$1" == "" ]; then
	echo "Input argument: specify database directory"
	exit;
fi
database_dir="${1}";
if [ ! -d "${database_dir}" ]; then
	echo "Input database directory \"${database_dir}\" does not exist."
	exit;
fi
database_name=`echo "$database_dir" | sed 's/\/$//' | gawk -F'/' '{print $NF}'`;
scratch_dir=/scratch/ashwin/asl/signstream_annotations/;
utterance_xml_list=../processed_annotations/${database_name}_utterance_xml;
temp_file="${scratch_dir}/${database_name}.xml";

if [ 1 -eq 1 ]; then
	find -L "$database_dir" -name "*.xml" > "$utterance_xml_list";
	if [ -f "${temp_file}" ]; then 	rm "${temp_file}"; fi
	while [ 1 ]; do
		read;
		if [ $? -ne 0 ]; then break; fi;
		xml_file=$REPLY;
		xml_file_path=${xml_file};

		file_modified_date=`ls -l --time-style=+%s "${xml_file_path}" | gawk -F' ' '{ print $6 }'`;

		echo -e "\n<TRACK FID=\"9999999\">\nPATH=${xml_file}\nXML_MODIFIED_DATE=${file_modified_date}\n" >> "$temp_file";
		cat "$xml_file_path" | remove_linebreaks.exe >> "$temp_file";

	done < "$utterance_xml_list";
fi

./process_annotations.sh "$temp_file" > ../processed_annotations/"${database_name}".out;
